Index: pjproject/trunk/pjmedia/src/pjmedia/codec.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/codec.c	(revision 410)
+++ pjproject/trunk/pjmedia/src/pjmedia/codec.c	(revision 411)
@@ -19,34 +19,18 @@
 #include <pjmedia/codec.h>
 #include <pjmedia/errno.h>
+#include <pj/array.h>
+#include <pj/assert.h>
+#include <pj/log.h>
 #include <pj/pool.h>
 #include <pj/string.h>
-#include <pj/assert.h>
-#include <pj/log.h>
 
 #define THIS_FILE   "codec.c"
 
-/*
- * Reinitialize array of supported codecs.
- */
-static void enum_all_codecs (pjmedia_codec_mgr *mgr)
-{
-    pjmedia_codec_factory *factory;
-
-    mgr->codec_cnt = 0;
-
-    factory = mgr->factory_list.next;
-    while (factory != &mgr->factory_list) {
-	unsigned count;
-	pj_status_t status;
-
-	count = PJ_ARRAY_SIZE(mgr->codecs) - mgr->codec_cnt;
-	status = factory->op->enum_info(factory, &count, 
-					mgr->codecs+mgr->codec_cnt);
-	if (status == PJ_SUCCESS)
-	    mgr->codec_cnt += count;
-
-	factory = factory->next;
-    }
-}
+
+
+
+/* Sort codecs in codec manager based on priorities */
+static void sort_codecs(pjmedia_codec_mgr *mgr);
+
 
 /*
@@ -62,4 +46,5 @@
     return PJ_SUCCESS;
 }
+
 
 /*
@@ -70,11 +55,46 @@
 				    pjmedia_codec_factory *factory)
 {
+    pjmedia_codec_info info[PJMEDIA_CODEC_MGR_MAX_CODECS];
+    unsigned i, count;
+    pj_status_t status;
+
     PJ_ASSERT_RETURN(mgr && factory, PJ_EINVAL);
 
+    /* Enum codecs */
+    count = PJ_ARRAY_SIZE(info);
+    status = factory->op->enum_info(factory, &count, info);
+    if (status != PJ_SUCCESS)
+	return status;
+    
+
+    /* Check codec count */
+    if (count + mgr->codec_cnt > PJ_ARRAY_SIZE(mgr->codec_desc))
+	return PJ_ETOOMANY;
+
+
+    /* Save the codecs */
+    for (i=0; i<count; ++i) {
+	pj_memcpy( &mgr->codec_desc[mgr->codec_cnt+i],
+		   &info[i], sizeof(pjmedia_codec_info));
+	mgr->codec_desc[mgr->codec_cnt+i].prio = PJMEDIA_CODEC_PRIO_NORMAL;
+	mgr->codec_desc[mgr->codec_cnt+i].factory = factory;
+	pjmedia_codec_info_to_id( &info[i],
+				  mgr->codec_desc[mgr->codec_cnt+i].id,
+				  sizeof(pjmedia_codec_id));
+    }
+
+    /* Update count */
+    mgr->codec_cnt += count;
+
+    /* Re-sort codec based on priorities */
+    sort_codecs(mgr);
+
+    /* Add factory to the list */
     pj_list_push_back(&mgr->factory_list, factory);
-    enum_all_codecs (mgr);
+
 
     return PJ_SUCCESS;
 }
+
 
 /*
@@ -85,5 +105,5 @@
 				     pjmedia_codec_factory *factory)
 {
-
+    unsigned i;
     PJ_ASSERT_RETURN(mgr && factory, PJ_EINVAL);
 
@@ -92,10 +112,28 @@
 		     PJ_ENOTFOUND);
 
-
+    /* Erase factory from the factory list */
     pj_list_erase(factory);
-    enum_all_codecs (mgr);
+
+
+    /* Remove all supported codecs from the codec manager that were created 
+     * by the specified factory.
+     */
+    for (i=0; i<mgr->codec_cnt; ) {
+
+	if (mgr->codec_desc[i].factory == factory) {
+
+	    pj_array_erase(mgr->codec_desc, sizeof(mgr->codec_desc[0]), 
+			   mgr->codec_cnt, i);
+	    --mgr->codec_cnt;
+
+	} else {
+	    ++i;
+	}
+    }
+
 
     return PJ_SUCCESS;
 }
+
 
 /*
@@ -105,6 +143,9 @@
 pjmedia_codec_mgr_enum_codecs(pjmedia_codec_mgr *mgr, 
 			      unsigned *count, 
-			      pjmedia_codec_info codecs[])
-{
+			      pjmedia_codec_info codecs[],
+			      unsigned *prio)
+{
+    unsigned i;
+
     PJ_ASSERT_RETURN(mgr && count && codecs, PJ_EINVAL);
 
@@ -112,23 +153,34 @@
 	*count = mgr->codec_cnt;
     
-    pj_memcpy(codecs, mgr->codecs, *count * sizeof(pjmedia_codec_info));
+    for (i=0; i<*count; ++i) {
+	pj_memcpy(&codecs[i], 
+		  &mgr->codec_desc[i].info, 
+		  sizeof(pjmedia_codec_info));
+    }
+
+    if (prio) {
+	for (i=0; i < *count; ++i)
+	    prio[i] = mgr->codec_desc[i].prio;
+    }
 
     return PJ_SUCCESS;
 }
 
+
 /*
  * Get codec info for static payload type.
  */
-PJ_DEF(pj_status_t) pjmedia_codec_mgr_get_codec_info(pjmedia_codec_mgr *mgr,
-						     unsigned pt,
-						     pjmedia_codec_info *inf)
+PJ_DEF(pj_status_t) 
+pjmedia_codec_mgr_get_codec_info( pjmedia_codec_mgr *mgr,
+				  unsigned pt,
+				  const pjmedia_codec_info **p_info)
 {
     unsigned i;
 
-    PJ_ASSERT_RETURN(mgr && inf && pt>=0 && pt < 96, PJ_EINVAL);
+    PJ_ASSERT_RETURN(mgr && p_info && pt>=0 && pt < 96, PJ_EINVAL);
 
     for (i=0; i<mgr->codec_cnt; ++i) {
-	if (mgr->codecs[i].pt == pt) {
-	    pj_memcpy(inf, &mgr->codecs[i], sizeof(pjmedia_codec_info));
+	if (mgr->codec_desc[i].info.pt == pt) {
+	    *p_info = &mgr->codec_desc[i].info;
 	    return PJ_SUCCESS;
 	}
@@ -137,4 +189,153 @@
     return PJMEDIA_CODEC_EUNSUP;
 }
+
+
+/*
+ * Convert codec info struct into a unique codec identifier.
+ * A codec identifier looks something like "L16/44100/2".
+ */
+PJ_DEF(char*) pjmedia_codec_info_to_id( const pjmedia_codec_info *info,
+				        char *id, unsigned max_len )
+{
+    int len;
+
+    PJ_ASSERT_RETURN(info && id && max_len, NULL);
+
+    len = pj_ansi_snprintf(id, max_len, "%.*s/%u/%u", 
+			   (int)info->encoding_name.slen,
+			   info->encoding_name.ptr,
+			   info->clock_rate,
+			   info->channel_cnt);
+
+    if (len < 1 || len >= (int)max_len) {
+	id[0] = '\0';
+	return NULL;
+    }
+
+    return id;
+}
+
+
+/*
+ * Find codecs by the unique codec identifier. This function will find
+ * all codecs that match the codec identifier prefix. For example, if
+ * "L16" is specified, then it will find "L16/8000/1", "L16/16000/1",
+ * and so on, up to the maximum count specified in the argument.
+ */
+PJ_DEF(pj_status_t) 
+pjmedia_codec_mgr_find_codecs_by_id( pjmedia_codec_mgr *mgr,
+				     const pj_str_t *codec_id,
+				     unsigned *count,
+				     const pjmedia_codec_info *p_info[],
+				     unsigned prio[])
+{
+    unsigned i, found = 0;
+
+    PJ_ASSERT_RETURN(mgr && codec_id && count && *count, PJ_EINVAL);
+
+    for (i=0; i<mgr->codec_cnt; ++i) {
+
+	if (pj_strnicmp2(codec_id, mgr->codec_desc[i].id, 
+			 codec_id->slen) == 0) 
+	{
+
+	    if (p_info)
+		p_info[found] = &mgr->codec_desc[i].info;
+	    if (prio)
+		prio[found] = mgr->codec_desc[i].prio;
+
+	    ++found;
+
+	    if (found >= *count)
+		break;
+	}
+
+    }
+
+    *count = found;
+
+    return found ? PJ_SUCCESS : PJ_ENOTFOUND;
+}
+
+
+/* Swap two codecs positions in codec manager */
+static void swap_codec(pjmedia_codec_mgr *mgr, unsigned i, unsigned j)
+{
+    struct pjmedia_codec_desc tmp;
+
+    pj_memcpy(&tmp, &mgr->codec_desc[i], sizeof(struct pjmedia_codec_desc));
+
+    pj_memcpy(&mgr->codec_desc[i], &mgr->codec_desc[j], 
+	       sizeof(struct pjmedia_codec_desc));
+
+    pj_memcpy(&mgr->codec_desc[j], &tmp, sizeof(struct pjmedia_codec_desc));
+}
+
+
+/* Sort codecs in codec manager based on priorities */
+static void sort_codecs(pjmedia_codec_mgr *mgr)
+{
+    unsigned i;
+
+   /* Re-sort */
+    for (i=0; i<mgr->codec_cnt; ++i) {
+	unsigned j, max;
+
+	for (max=i, j=i+1; j<mgr->codec_cnt; ++j) {
+	    if (mgr->codec_desc[j].prio > mgr->codec_desc[max].prio)
+		max = j;
+	}
+
+	if (max != i)
+	    swap_codec(mgr, i, max);
+    }
+
+    /* Change PJMEDIA_CODEC_PRIO_HIGHEST codecs to NEXT_HIGHER */
+    for (i=0; i<mgr->codec_cnt; ++i) {
+	if (mgr->codec_desc[i].prio == PJMEDIA_CODEC_PRIO_HIGHEST)
+	    mgr->codec_desc[i].prio = PJMEDIA_CODEC_PRIO_NEXT_HIGHER;
+	else
+	    break;
+    }
+}
+
+
+/**
+ * Set codec priority. The codec priority determines the order of
+ * the codec in the SDP created by the endpoint. If more than one codecs
+ * are found with the same codec_id prefix, then the function sets the
+ * priorities of all those codecs.
+ */
+PJ_DEF(pj_status_t)
+pjmedia_codec_mgr_set_codec_priority(pjmedia_codec_mgr *mgr, 
+				     const pj_str_t *codec_id,
+				     pjmedia_codec_priority prio)
+{
+    unsigned i, found = 0;
+
+    PJ_ASSERT_RETURN(mgr && codec_id, PJ_EINVAL);
+
+    /* Update the priorities of affected codecs */
+    for (i=0; i<mgr->codec_cnt; ++i) 
+    {
+	if (codec_id->slen == 0 ||
+	    pj_strnicmp2(codec_id, mgr->codec_desc[i].id, 
+			 codec_id->slen) == 0) 
+	{
+	    mgr->codec_desc[i].prio = prio;
+	    ++found;
+	}
+    }
+
+    if (!found)
+	return PJ_ENOTFOUND;
+
+    /* Re-sort codecs */
+    sort_codecs(mgr);
+ 
+
+    return PJ_SUCCESS;
+}
+
 
 /*
Index: pjproject/trunk/pjmedia/src/pjmedia/conference.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/conference.c	(revision 410)
+++ pjproject/trunk/pjmedia/src/pjmedia/conference.c	(revision 411)
@@ -238,5 +238,5 @@
     if (port) {
 	conf_port->port = port;
-	conf_port->clock_rate = port->info.sample_rate;
+	conf_port->clock_rate = port->info.clock_rate;
 	conf_port->samples_per_frame = port->info.samples_per_frame;
     } else {
@@ -443,5 +443,5 @@
     conf->master_port->info.need_info = 0;
     conf->master_port->info.pt = 0xFF;
-    conf->master_port->info.sample_rate = clock_rate;
+    conf->master_port->info.clock_rate = clock_rate;
     conf->master_port->info.samples_per_frame = samples_per_frame;
     conf->master_port->info.signature = 0;
@@ -1091,4 +1091,5 @@
     pj_int16_t *buf;
     unsigned j;
+    pj_status_t status;
 
     /* If port is muted or nobody is transmitting to this port, 
@@ -1181,5 +1182,5 @@
     }
 
-    /* If port has the same clock_date and samples_per_frame settings as
+    /* If port has the same clock_rate and samples_per_frame settings as
      * the conference bridge, transmit the frame as is.
      */
@@ -1225,9 +1226,10 @@
     }
 
-    /* Transmit once we have enough frame in the tx_buf. */
-    if (cport->tx_buf_count >= cport->samples_per_frame) {
+    /* Transmit while we have enough frame in the tx_buf. */
+    status = PJ_SUCCESS;
+    while (cport->tx_buf_count >= cport->samples_per_frame &&
+	   status == PJ_SUCCESS) 
+    {
 	
-	pj_status_t status;
-
 	TRACE_((THIS_FILE, "write_port %.*s: count=%d", 
 			   (int)cport->name.slen, cport->name.ptr,
@@ -1260,9 +1262,7 @@
 	TRACE_((THIS_FILE, " tx_buf count now is %d", 
 			   cport->tx_buf_count));
-
-	return status;
-    }
-
-    return PJ_SUCCESS;
+    }
+
+    return status;
 }
 
Index: pjproject/trunk/pjmedia/src/pjmedia/endpoint.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/endpoint.c	(revision 410)
+++ pjproject/trunk/pjmedia/src/pjmedia/endpoint.c	(revision 411)
@@ -330,8 +330,15 @@
     for (i=0; i<endpt->codec_mgr.codec_cnt; ++i) {
 
-	pjmedia_codec_info *codec_info = &endpt->codec_mgr.codecs[i];
+	pjmedia_codec_info *codec_info;
 	pjmedia_sdp_rtpmap rtpmap;
+	char tmp_param[3];
 	pjmedia_sdp_attr *attr;
-	pj_str_t *fmt = &m->desc.fmt[m->desc.fmt_count++];
+	pj_str_t *fmt;
+
+	if (endpt->codec_mgr.codec_desc[i].prio == PJMEDIA_CODEC_PRIO_DISABLED)
+	    break;
+
+	codec_info = &endpt->codec_mgr.codec_desc[i].info;
+	fmt = &m->desc.fmt[m->desc.fmt_count++];
 
 	fmt->ptr = pj_pool_alloc(pool, 8);
@@ -339,7 +346,25 @@
 
 	rtpmap.pt = *fmt;
-	rtpmap.clock_rate = codec_info->sample_rate;
+	rtpmap.clock_rate = codec_info->clock_rate;
 	rtpmap.enc_name = codec_info->encoding_name;
-	rtpmap.param.slen = 0;
+	
+	/* For audio codecs, rtpmap parameters denotes the number
+	 * of channels, which can be omited if the value is 1.
+	 */
+	if (codec_info->type == PJMEDIA_TYPE_AUDIO &&
+	    codec_info->channel_cnt > 1)
+	{
+	    /* Can only support one digit channel count */
+	    pj_assert(codec_info->channel_cnt < 10);
+
+	    tmp_param[0] = '/';
+	    tmp_param[1] = (char)('0' + codec_info->channel_cnt);
+
+	    rtpmap.param.ptr = tmp_param;
+	    rtpmap.param.slen = 2;
+
+	} else {
+	    rtpmap.param.slen = 0;
+	}
 
 	pjmedia_sdp_rtpmap_to_attr(pool, &rtpmap, &attr);
@@ -389,5 +414,5 @@
     count = PJ_ARRAY_SIZE(codec_info);
     if (pjmedia_codec_mgr_enum_codecs(&endpt->codec_mgr, 
-				      &count, codec_info) != PJ_SUCCESS)
+				      &count, codec_info, NULL) != PJ_SUCCESS)
     {
 	PJ_LOG(3,(THIS_FILE, " -error: failed to enum codecs"));
@@ -417,12 +442,13 @@
 
 	PJ_LOG(3,(THIS_FILE, 
-		  "   %s codec #%2d: pt=%d (%.*s @%dKHz, %d bps, ptime=%d ms, vad=%d, cng=%d)", 
+		  "   %s codec #%2d: pt=%d (%.*s @%dKHz/%d, %d bps, ptime=%d ms, vad=%d, cng=%d)", 
 		  type, i, codec_info[i].pt,
 		  (int)codec_info[i].encoding_name.slen,
 		  codec_info[i].encoding_name.ptr,
-		  codec_info[i].sample_rate/1000,
+		  codec_info[i].clock_rate/1000,
+		  codec_info[i].channel_cnt,
 		  param.avg_bps, param.ptime,
-		  param.vad_enabled,
-		  param.cng_enabled));
+		  param.vad,
+		  param.cng));
     }
 #endif
Index: pjproject/trunk/pjmedia/src/pjmedia/g711.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/g711.c	(revision 410)
+++ pjproject/trunk/pjmedia/src/pjmedia/g711.c	(revision 411)
@@ -36,5 +36,4 @@
 /* These are the only public functions exported to applications */
 PJ_DECL(pj_status_t) g711_init_factory (pjmedia_codec_factory *factory, pj_pool_t *pool);
-PJ_DECL(pj_status_t) g711_deinit_factory (pjmedia_codec_factory *factory);
 
 /* Algorithm prototypes. */
@@ -60,6 +59,4 @@
 
 /* Prototypes for G711 implementation. */
-static pj_status_t  g711_codec_default_attr (pjmedia_codec *codec, 
-					     pjmedia_codec_param *attr);
 static pj_status_t  g711_init( pjmedia_codec *codec, 
 			       pj_pool_t *pool );
@@ -84,5 +81,4 @@
 static pjmedia_codec_op g711_op = 
 {
-    &g711_codec_default_attr ,
     &g711_init,
     &g711_open,
@@ -120,13 +116,4 @@
 
 
-PJ_DEF(pj_status_t) g711_deinit_factory (pjmedia_codec_factory *factory)
-{
-    PJ_ASSERT_RETURN(factory==&g711_factory.base, PJ_EINVAL);
-
-    /* Invalidate member to help detect errors */
-    g711_factory.codec_list.next = g711_factory.codec_list.prev = NULL;
-    return 0;
-}
-
 PJ_DEF(pj_status_t) pjmedia_codec_g711_init(pjmedia_endpt *endpt)
 {
@@ -223,5 +210,6 @@
 }
 
-static pj_status_t g711_test_alloc( pjmedia_codec_factory *factory, const pjmedia_codec_info *id )
+static pj_status_t g711_test_alloc(pjmedia_codec_factory *factory, 
+				   const pjmedia_codec_info *id )
 {
     PJ_UNUSED_ARG(factory);
@@ -238,5 +226,6 @@
 
     pj_memset(attr, 0, sizeof(pjmedia_codec_param));
-    attr->sample_rate = 8000;
+    attr->clock_rate = 8000;
+    attr->channel_cnt = 1;
     attr->avg_bps = G711_BPS;
     attr->pcm_bits_per_sample = 16;
@@ -261,12 +250,14 @@
 	codecs[count].pt = PJMEDIA_RTP_PT_PCMU;
 	codecs[count].encoding_name = pj_str("PCMU");
-	codecs[count].sample_rate = 8000;
+	codecs[count].clock_rate = 8000;
+	codecs[count].channel_cnt = 1;
 	++count;
     }
     if (count < *max_count) {
-	codecs[1].type = PJMEDIA_TYPE_AUDIO;
-	codecs[1].pt = PJMEDIA_RTP_PT_PCMA;
-	codecs[1].encoding_name = pj_str("PCMA");
-	codecs[1].sample_rate = 8000;
+	codecs[count].type = PJMEDIA_TYPE_AUDIO;
+	codecs[count].pt = PJMEDIA_RTP_PT_PCMA;
+	codecs[count].encoding_name = pj_str("PCMA");
+	codecs[count].clock_rate = 8000;
+	codecs[count].channel_cnt = 1;
 	++count;
     }
@@ -293,5 +284,6 @@
 
 	codec = pj_pool_alloc(g711_factory.pool, sizeof(pjmedia_codec));
-	codec_priv = pj_pool_alloc(g711_factory.pool, sizeof(struct g711_private));
+	codec_priv = pj_pool_alloc(g711_factory.pool, 
+				   sizeof(struct g711_private));
 	if (!codec || !codec_priv) {
 	    pj_mutex_unlock(g711_factory.mutex);
@@ -320,5 +312,6 @@
 }
 
-static pj_status_t g711_dealloc_codec( pjmedia_codec_factory *factory, pjmedia_codec *codec )
+static pj_status_t g711_dealloc_codec(pjmedia_codec_factory *factory, 
+				      pjmedia_codec *codec )
 {
     
@@ -343,13 +336,4 @@
 }
 
-static pj_status_t g711_codec_default_attr  (pjmedia_codec *codec, pjmedia_codec_param *attr)
-{
-    struct g711_private *priv = codec->codec_data;
-    pjmedia_codec_info id;
-
-    id.pt = priv->pt;
-    return g711_default_attr (NULL, &id, attr);
-}
-
 static pj_status_t g711_init( pjmedia_codec *codec, pj_pool_t *pool )
 {
@@ -361,5 +345,6 @@
 }
 
-static pj_status_t g711_open( pjmedia_codec *codec, pjmedia_codec_param *attr )
+static pj_status_t g711_open(pjmedia_codec *codec, 
+			     pjmedia_codec_param *attr )
 {
     struct g711_private *priv = codec->codec_data;
@@ -401,6 +386,8 @@
 }
 
-static pj_status_t  g711_encode( pjmedia_codec *codec, const struct pjmedia_frame *input,
-				 unsigned output_buf_len, struct pjmedia_frame *output)
+static pj_status_t  g711_encode(pjmedia_codec *codec, 
+				const struct pjmedia_frame *input,
+				unsigned output_buf_len, 
+				struct pjmedia_frame *output)
 {
     pj_int16_t *samples = (pj_int16_t*) input->buf;
@@ -409,5 +396,5 @@
     /* Check output buffer length */
     if (output_buf_len < input->size / 2)
-	return -1;
+	return PJMEDIA_CODEC_EFRMTOOSHORT;
 
     /* Encode */
@@ -428,5 +415,5 @@
 
     } else {
-	return -1;
+	return PJMEDIA_EINVALIDPT;
     }
 
@@ -434,9 +421,11 @@
     output->size = input->size / 2;
 
-    return 0;
-}
-
-static pj_status_t  g711_decode( pjmedia_codec *codec, const struct pjmedia_frame *input,
-				 unsigned output_buf_len, struct pjmedia_frame *output)
+    return PJ_SUCCESS;
+}
+
+static pj_status_t  g711_decode(pjmedia_codec *codec, 
+				const struct pjmedia_frame *input,
+				unsigned output_buf_len, 
+				struct pjmedia_frame *output)
 {
     struct g711_private *priv = codec->codec_data;
@@ -444,5 +433,5 @@
     /* Check output buffer length */
     if (output_buf_len < input->size * 2)
-	return -1;
+	return PJMEDIA_CODEC_EPCMTOOSHORT;
 
     /* Decode */
@@ -465,5 +454,5 @@
 
     } else {
-	return -1;
+	return PJMEDIA_EINVALIDPT;
     }
 
@@ -471,5 +460,5 @@
     output->size = input->size * 2;
 
-    return 0;
+    return PJ_SUCCESS;
 }
 
Index: pjproject/trunk/pjmedia/src/pjmedia/jbuf.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/jbuf.c	(revision 410)
+++ pjproject/trunk/pjmedia/src/pjmedia/jbuf.c	(revision 411)
@@ -323,5 +323,5 @@
 static void jbuf_calculate_jitter(pjmedia_jbuf *jb)
 {
-    enum { STABLE_HISTORY_LIMIT = (500/20) };
+    enum { STABLE_HISTORY_LIMIT = (100*2) };
 
     jb->jb_last_jitter = PJ_ABS(jb->jb_level-jb->jb_last_level);
@@ -342,5 +342,5 @@
 	    jb->jb_max_hist_jitter = 0;
 
-	    if (jb->jb_op_count >= 100 &&
+	    if (jb->jb_op_count >= STABLE_HISTORY_LIMIT*2 &&
 		(int)jb_framelist_size(&jb->jb_framelist) > jb->jb_prefetch+2)
 	    {
@@ -361,5 +361,5 @@
 	jb->jb_max_hist_jitter = 0;
 
-	if (jb->jb_op_count >= 100) {
+	if (jb->jb_op_count >= STABLE_HISTORY_LIMIT * 2) {
 	    if ((int)jb_framelist_size(&jb->jb_framelist) > jb->jb_prefetch+2) 
 	    {
Index: pjproject/trunk/pjmedia/src/pjmedia/master_port.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/master_port.c	(revision 410)
+++ pjproject/trunk/pjmedia/src/pjmedia/master_port.c	(revision 411)
@@ -60,11 +60,11 @@
 
     /* Both ports MUST have the equal ptime */
-    PJ_ASSERT_RETURN(u_port->info.sample_rate/u_port->info.samples_per_frame==
-		     d_port->info.sample_rate/d_port->info.samples_per_frame,
+    PJ_ASSERT_RETURN(u_port->info.clock_rate/u_port->info.samples_per_frame==
+		     d_port->info.clock_rate/d_port->info.samples_per_frame,
 		     PJMEDIA_ENCSAMPLESPFRAME);
 
 
     /* Get clock_rate and samples_per_frame from one of the port. */
-    clock_rate = u_port->info.sample_rate;
+    clock_rate = u_port->info.clock_rate;
     samples_per_frame = u_port->info.samples_per_frame;
 
Index: pjproject/trunk/pjmedia/src/pjmedia/null_port.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/null_port.c	(revision 410)
+++ pjproject/trunk/pjmedia/src/pjmedia/null_port.c	(revision 411)
@@ -52,5 +52,5 @@
     port->info.need_info = 0;
     port->info.pt = 0xFF;
-    port->info.sample_rate = sampling_rate;
+    port->info.clock_rate = sampling_rate;
     port->info.samples_per_frame = samples_per_frame;
     port->info.channel_count = channel_count;
Index: pjproject/trunk/pjmedia/src/pjmedia/resample_port.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/resample_port.c	(revision 410)
+++ pjproject/trunk/pjmedia/src/pjmedia/resample_port.c	(revision 411)
@@ -76,5 +76,5 @@
     rport->base.info.need_info = 0;
     rport->base.info.pt = 0xFF;
-    rport->base.info.sample_rate = upstream_rate;
+    rport->base.info.clock_rate = upstream_rate;
     rport->base.info.samples_per_frame = upstream_samples_per_frame;
     rport->base.info.signature = 0;
Index: pjproject/trunk/pjmedia/src/pjmedia/rtcp.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/rtcp.c	(revision 410)
+++ pjproject/trunk/pjmedia/src/pjmedia/rtcp.c	(revision 411)
@@ -134,6 +134,10 @@
     pj_time_val now;
     
+    /* Reset packet */
     pj_memset(rtcp_pkt, 0, sizeof(pjmedia_rtcp_pkt));
     
+    /* Reset statistics */
+    pj_memset(&sess->stat, 0, sizeof(pjmedia_rtcp_stat));
+
     /* Name */
     sess->name = name ? name : THIS_FILE,
Index: pjproject/trunk/pjmedia/src/pjmedia/session.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/session.c	(revision 410)
+++ pjproject/trunk/pjmedia/src/pjmedia/session.c	(revision 411)
@@ -195,14 +195,35 @@
 	    si->fmt.pt = pj_strtoul(&local_m->desc.fmt[0]);
 	    pj_strdup(pool, &si->fmt.encoding_name, &rtpmap->enc_name);
-	    si->fmt.sample_rate = rtpmap->clock_rate;
+	    si->fmt.clock_rate = rtpmap->clock_rate;
+	    
+	    /* For audio codecs, rtpmap parameters denotes the number of
+	     * channels.
+	     */
+	    if (si->type == PJMEDIA_TYPE_AUDIO && rtpmap->param.slen) {
+		
+		if (rtpmap->param.slen == 2) {
+		    si->fmt.channel_cnt = rtpmap->param.ptr[1] - '0';
+		} else {
+		    pj_str_t cnt;
+		    cnt.ptr = rtpmap->param.ptr + 1;
+		    cnt.slen = rtpmap->param.slen - 1;
+		    si->fmt.channel_cnt = (unsigned) pj_strtoul(&cnt);
+		}
+
+	    } else {
+		si->fmt.channel_cnt = 1;
+	    }
 
 	} else {
 	    pjmedia_codec_mgr *mgr;
+	    pjmedia_codec_info *p_info;
 
 	    mgr = pjmedia_endpt_get_codec_mgr(endpt);
 
-	    status = pjmedia_codec_mgr_get_codec_info( mgr, pt, &si->fmt);
+	    status = pjmedia_codec_mgr_get_codec_info( mgr, pt, &p_info);
 	    if (status != PJ_SUCCESS)
 		return status;
+
+	    pj_memcpy(&si->fmt, p_info, sizeof(pjmedia_codec_info));
 	}
 
@@ -225,5 +246,23 @@
 	si->fmt.pt = pj_strtoul(&local_m->desc.fmt[0]);
 	pj_strdup(pool, &si->fmt.encoding_name, &rtpmap->enc_name);
-	si->fmt.sample_rate = rtpmap->clock_rate;
+	si->fmt.clock_rate = rtpmap->clock_rate;
+
+	/* For audio codecs, rtpmap parameters denotes the number of
+	 * channels.
+	 */
+	if (si->type == PJMEDIA_TYPE_AUDIO && rtpmap->param.slen) {
+	    
+	    if (rtpmap->param.slen == 2) {
+		si->fmt.channel_cnt = rtpmap->param.ptr[1] - '0';
+	    } else {
+		pj_str_t cnt;
+		cnt.ptr = rtpmap->param.ptr + 1;
+		cnt.slen = rtpmap->param.slen - 1;
+		si->fmt.channel_cnt = (unsigned) pj_strtoul(&cnt);
+	    }
+
+	} else {
+	    si->fmt.channel_cnt = 1;
+	}
 
 	/* Determine payload type for outgoing channel, by finding
Index: pjproject/trunk/pjmedia/src/pjmedia/sound_port.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/sound_port.c	(revision 410)
+++ pjproject/trunk/pjmedia/src/pjmedia/sound_port.c	(revision 411)
@@ -345,5 +345,5 @@
      */
     pinfo = &port->info;
-    if (pinfo->sample_rate != snd_port->clock_rate)
+    if (pinfo->clock_rate != snd_port->clock_rate)
 	return PJMEDIA_ENCCLOCKRATE;
 
Index: pjproject/trunk/pjmedia/src/pjmedia/stream.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/stream.c	(revision 410)
+++ pjproject/trunk/pjmedia/src/pjmedia/stream.c	(revision 411)
@@ -159,4 +159,10 @@
     struct pjmedia_frame frame_in, frame_out;
 
+    /* Return no frame is channel is paused */
+    if (channel->paused) {
+	frame->type = PJMEDIA_FRAME_TYPE_NONE;
+	return PJ_SUCCESS;
+    }
+
     /* Lock jitter buffer mutex */
     pj_mutex_lock( stream->jb_mutex );
@@ -175,5 +181,4 @@
 	return PJ_SUCCESS;
     }
-
 
     /* Decode */
@@ -321,4 +326,10 @@
     int rtphdrlen;
     pj_ssize_t sent;
+
+
+    /* Don't do anything if stream is paused */
+    if (channel->paused)
+	return PJ_SUCCESS;
+
 
     /* Number of samples in the frame */
@@ -758,5 +769,6 @@
     /* Allocate buffer for decoding to PCM: */
 
-    channel->pcm_buf_size = codec_param->sample_rate * 
+    channel->pcm_buf_size = codec_param->clock_rate * 
+			    codec_param->channel_cnt *
 			    codec_param->pcm_bits_per_sample / 8 *
 			    PJMEDIA_MAX_FRAME_DURATION_MS / 1000;
@@ -791,4 +803,5 @@
     pj_ioqueue_callback ioqueue_cb;
     pj_uint16_t rtcp_port;
+    unsigned jbuf_init, jbuf_max;
     pj_status_t status;
 
@@ -814,6 +827,6 @@
     stream->port.info.pt = info->fmt.pt;
     pj_strdup(pool, &stream->port.info.encoding_name, &info->fmt.encoding_name);
-    stream->port.info.channel_count = 1;
-    stream->port.info.sample_rate = info->fmt.sample_rate;
+    stream->port.info.clock_rate = info->fmt.clock_rate;
+    stream->port.info.channel_count = info->fmt.channel_cnt;
     stream->port.user_data = stream;
     stream->port.put_frame = &put_frame;
@@ -832,5 +845,5 @@
     stream->rem_rtcp_addr.sin_port = pj_htons(rtcp_port);
     stream->rtcp_interval = (PJMEDIA_RTCP_INTERVAL + (pj_rand() % 8000)) * 
-			    info->fmt.sample_rate / 1000;
+			    info->fmt.clock_rate / 1000;
 
     stream->tx_event_pt = info->tx_event_pt ? info->tx_event_pt : -1;
@@ -856,5 +869,7 @@
     /* Get default codec param: */
 
-    status = stream->codec->op->default_attr(stream->codec, &codec_param);
+    //status = stream->codec->op->default_attr(stream->codec, &codec_param);
+    status = pjmedia_codec_mgr_get_default_param( stream->codec_mgr, 
+						  &info->fmt, &codec_param);
     if (status != PJ_SUCCESS)
 	goto err_cleanup;
@@ -862,5 +877,5 @@
     /* Set additional info. */
     stream->port.info.bits_per_sample = 16;
-    stream->port.info.samples_per_frame = info->fmt.sample_rate*codec_param.ptime/1000;
+    stream->port.info.samples_per_frame = info->fmt.clock_rate*codec_param.ptime/1000;
     stream->port.info.bytes_per_frame = codec_param.avg_bps/8 * codec_param.ptime/1000;
 
@@ -881,5 +896,5 @@
 
     pjmedia_rtcp_init(&stream->rtcp, stream->port.info.name.ptr,
-		      info->fmt.sample_rate, 
+		      info->fmt.clock_rate, 
 		      stream->port.info.samples_per_frame, 
 		      info->ssrc);
@@ -887,7 +902,11 @@
 
     /* Create jitter buffer: */
-
+    jbuf_init = 100 / (stream->port.info.samples_per_frame * 1000 / 
+		       info->fmt.clock_rate);
+    jbuf_max = 600 / (stream->port.info.samples_per_frame * 1000 / 
+		       info->fmt.clock_rate);
     status = pjmedia_jbuf_create(pool, &stream->port.info.name,
-				 stream->frame_size, 15, 100,
+				 stream->frame_size, 
+				 jbuf_init, jbuf_max,
 				 &stream->jb);
     if (status != PJ_SUCCESS)
